import { httpApp } from "@/plugins/axiosApp";

/** 用户登录 */
export async function loginApi(
  accountType: string,
  accountValue: string,
  password: string,
  domain: string,
  rootOrgId: number
) {
  return httpApp.post<{ code: string; desc: string; content: any }>(
    "/api/ecs_core/verifyCode/gt/login",
    {
      accountType,
      accountValue,
      password,
      domain,
      rootOrgId,
      alwaysOK: true,
    },
    { setGlobalMask: true }
  );
}

/** 用户登录后获取额外信息 */
export async function getStudentInfoBySessionApi() {
  return httpApp.get<any>("/api/ecs_core/student/getStudentInfoBySession", {
    setGlobalMask: true,
  });
}

/** 用户登录后获取专业 */
export async function getStudentSpecialtyNameListApi() {
  return httpApp.get<string[]>(
    "/api/ecs_exam_work/exam_student/specialtyNameList/",
    { setGlobalMask: true }
  );
}
